import { ObservableObject } from 'reactronic';
export declare class Sensor extends ObservableObject {
    revision: number;
    nativeElements: unknown[];
    private composedAssociatedDataList;
    get associatedDataList(): unknown[];
    set associatedDataList(value: unknown[]);
}
export declare enum KeyboardModifiers {
    None = 0,
    Ctrl = 1,
    Shift = 2,
    Alt = 4,
    Meta = 8,
    CtrlShift = 3,
    CtrlAlt = 5,
    CtrlMeta = 9,
    CtrlShiftAlt = 7,
    CtrlShiftAltMeta = 15,
    CtrlShiftMeta = 11,
    ShiftAlt = 6,
    ShiftMeta = 10,
    ShiftAltMeta = 14,
    AltMeta = 12
}
export declare class Keyboard extends Sensor {
    down: string;
    up: string;
    modifiers: KeyboardModifiers;
}
export declare enum PointerButton {
    None = 0,
    Left = 1,
    Right = 2,
    Middle = 4
}
export declare class Pointer extends Sensor {
    captured: boolean;
    touched: boolean;
    positionX: number;
    positionY: number;
    previousPositionX: number;
    previousPositionY: number;
    down: PointerButton;
    up: PointerButton;
    click: PointerButton;
    doubleClick: PointerButton;
}
export declare class Scroll extends Sensor {
    positionX: number;
    positionY: number;
    deltaX: number;
    deltaY: number;
}
export declare const EMPTY_ASSOCIATED_DATA_LIST: any[];
