"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EMPTY_ASSOCIATED_DATA_LIST = exports.Scroll = exports.Pointer = exports.PointerButton = exports.Keyboard = exports.KeyboardModifiers = exports.Sensor = void 0;
const reactronic_1 = require("reactronic");
class Sensor extends reactronic_1.ObservableObject {
    constructor() {
        super(...arguments);
        this.revision = 0;
        this.nativeElements = [];
        this.composedAssociatedDataList = exports.EMPTY_ASSOCIATED_DATA_LIST;
    }
    get associatedDataList() { return reactronic_1.nonreactive(() => this.composedAssociatedDataList); }
    set associatedDataList(value) { this.composedAssociatedDataList = value; }
}
exports.Sensor = Sensor;
var KeyboardModifiers;
(function (KeyboardModifiers) {
    KeyboardModifiers[KeyboardModifiers["None"] = 0] = "None";
    KeyboardModifiers[KeyboardModifiers["Ctrl"] = 1] = "Ctrl";
    KeyboardModifiers[KeyboardModifiers["Shift"] = 2] = "Shift";
    KeyboardModifiers[KeyboardModifiers["Alt"] = 4] = "Alt";
    KeyboardModifiers[KeyboardModifiers["Meta"] = 8] = "Meta";
    KeyboardModifiers[KeyboardModifiers["CtrlShift"] = 3] = "CtrlShift";
    KeyboardModifiers[KeyboardModifiers["CtrlAlt"] = 5] = "CtrlAlt";
    KeyboardModifiers[KeyboardModifiers["CtrlMeta"] = 9] = "CtrlMeta";
    KeyboardModifiers[KeyboardModifiers["CtrlShiftAlt"] = 7] = "CtrlShiftAlt";
    KeyboardModifiers[KeyboardModifiers["CtrlShiftAltMeta"] = 15] = "CtrlShiftAltMeta";
    KeyboardModifiers[KeyboardModifiers["CtrlShiftMeta"] = 11] = "CtrlShiftMeta";
    KeyboardModifiers[KeyboardModifiers["ShiftAlt"] = 6] = "ShiftAlt";
    KeyboardModifiers[KeyboardModifiers["ShiftMeta"] = 10] = "ShiftMeta";
    KeyboardModifiers[KeyboardModifiers["ShiftAltMeta"] = 14] = "ShiftAltMeta";
    KeyboardModifiers[KeyboardModifiers["AltMeta"] = 12] = "AltMeta";
})(KeyboardModifiers = exports.KeyboardModifiers || (exports.KeyboardModifiers = {}));
class Keyboard extends Sensor {
    constructor() {
        super(...arguments);
        this.down = '';
        this.up = '';
        this.modifiers = KeyboardModifiers.None;
    }
}
exports.Keyboard = Keyboard;
var PointerButton;
(function (PointerButton) {
    PointerButton[PointerButton["None"] = 0] = "None";
    PointerButton[PointerButton["Left"] = 1] = "Left";
    PointerButton[PointerButton["Right"] = 2] = "Right";
    PointerButton[PointerButton["Middle"] = 4] = "Middle";
})(PointerButton = exports.PointerButton || (exports.PointerButton = {}));
class Pointer extends Sensor {
    constructor() {
        super(...arguments);
        this.captured = false;
        this.touched = false;
        this.positionX = 0;
        this.positionY = 0;
        this.previousPositionX = 0;
        this.previousPositionY = 0;
        this.down = PointerButton.None;
        this.up = PointerButton.None;
        this.click = PointerButton.None;
        this.doubleClick = PointerButton.None;
    }
}
exports.Pointer = Pointer;
class Scroll extends Sensor {
    constructor() {
        super(...arguments);
        this.positionX = 0;
        this.positionY = 0;
        this.deltaX = 0;
        this.deltaY = 0;
    }
}
exports.Scroll = Scroll;
exports.EMPTY_ASSOCIATED_DATA_LIST = [];
