"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.forAll = exports.trace = exports.cycle = exports.internalInstance = exports.instance = exports.unmount = exports.renderChildrenNow = exports.render = exports.manifest = exports.Manifest = exports.RefreshParent = void 0;
const reactronic_1 = require("reactronic");
exports.RefreshParent = Symbol('RefreshParent');
class Manifest {
    constructor(id, args, render, componentRender, rtti, mounted) {
        this.id = id;
        this.args = args;
        this.render = render;
        this.componentRender = componentRender;
        this.rtti = rtti;
        this.mounted = mounted;
    }
    get native() { var _a, _b; return (_b = (_a = this.mounted) === null || _a === void 0 ? void 0 : _a.instance) === null || _b === void 0 ? void 0 : _b.native; }
}
exports.Manifest = Manifest;
function manifest(id, args, render, componentRender, rtti) {
    var _a;
    const owner = gOwner;
    if (!((_a = owner.mounted) === null || _a === void 0 ? void 0 : _a.instance))
        throw new Error('element must be mounted before children');
    const m = new Manifest(id, args, render, componentRender, rtti);
    if (owner !== RootManifest) {
        if (gPending === undefined)
            throw new Error('children are rendered already');
        gPending.push(m);
    }
    else {
        gPending = [m];
        reactronic_1.Transaction.run(renderChildrenNow);
    }
    return m;
}
exports.manifest = manifest;
function render(m) {
    var _a, _b;
    const inst = (_a = m.mounted) === null || _a === void 0 ? void 0 : _a.instance;
    if (!inst)
        throw new Error('element must be mounted before rendering');
    const outerOwner = gOwner;
    const outerPending = gPending;
    try {
        gOwner = m;
        gPending = [];
        if (gTrace && gTraceMask.indexOf('r') >= 0 && new RegExp(gTrace, 'gi').test(getManifestTraceHint(m)))
            console.log(`t${reactronic_1.Transaction.current.id}v${reactronic_1.Transaction.current.timestamp}${'  '.repeat(Math.abs(m.mounted.level))}${getManifestTraceHint(m)}.render/${(_b = m.mounted) === null || _b === void 0 ? void 0 : _b.cycle}${m.args !== exports.RefreshParent ? `  <<  ${reactronic_1.Reactronic.why(true)}` : ''}`);
        if (m.componentRender)
            m.componentRender(componentRender, inst.native);
        else
            m.render(inst.native, undefined);
        renderChildrenNow();
    }
    finally {
        gPending = outerPending;
        gOwner = outerOwner;
    }
}
exports.render = render;
function componentRender(options) {
    var _a;
    const t = gOwner;
    const inst = (_a = t.mounted) === null || _a === void 0 ? void 0 : _a.instance;
    if (!inst)
        throw new Error('element must be mounted before rendering');
    t.render(inst.native, options);
    return options;
}
function renderChildrenNow() {
    const x = gOwner;
    if (x.rtti.sorting)
        reconcileSortedChildren(x);
    else
        reconcileOrdinaryChildren(x);
}
exports.renderChildrenNow = renderChildrenNow;
function unmount(m, owner, cause) {
    const inst = m.mounted.instance;
    for (const x of inst.children)
        callUnmount(x, m, cause);
    inst.native = undefined;
    m.mounted = undefined;
}
exports.unmount = unmount;
function instance() {
    var _a;
    const inst = (_a = gOwner.mounted) === null || _a === void 0 ? void 0 : _a.instance;
    if (!inst)
        throw new Error('instance function can be called only inside rendering function');
    return inst;
}
exports.instance = instance;
function internalInstance() {
    var _a;
    const inst = (_a = gOwner.mounted) === null || _a === void 0 ? void 0 : _a.instance;
    if (!inst)
        throw new Error('internalInstance function can be called only inside rendering function');
    return inst;
}
exports.internalInstance = internalInstance;
function cycle() {
    var _a, _b;
    return (_b = (_a = gOwner.mounted) === null || _a === void 0 ? void 0 : _a.cycle) !== null && _b !== void 0 ? _b : 0;
}
exports.cycle = cycle;
function trace(enabled, mask, regexp) {
    gTrace = enabled ? regexp : undefined;
    gTraceMask = mask;
}
exports.trace = trace;
function forAll(action) {
    forEachChildRecursively(RootManifest, action);
}
exports.forAll = forAll;
const EMPTY = [];
Object.freeze(EMPTY);
class Instance {
    constructor() {
        this.native = undefined;
        this.children = EMPTY;
    }
}
class Mounted {
    constructor(level, instance) {
        this.level = level;
        this.cycle = 0;
        this.instance = instance;
    }
    render(m) {
        renderInline(this, m);
        reactronic_1.Reactronic.configureCurrentMethod({ priority: this.level });
    }
}
__decorate([
    reactronic_1.reaction,
    reactronic_1.observableArgs(true),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Manifest]),
    __metadata("design:returntype", void 0)
], Mounted.prototype, "render", null);
function renderInline(mounted, m) {
    mounted.cycle++;
    m.rtti.render ? m.rtti.render(m) : render(m);
}
function callRender(m, owner) {
    const mounted = m.mounted;
    if (m.args === exports.RefreshParent)
        renderInline(mounted, m);
    else
        reactronic_1.nonreactive(mounted.render, m);
}
function callMount(m, owner, sibling) {
    var _a, _b;
    const rtti = m.rtti;
    const mounted = new Mounted(owner.mounted.level + 1);
    m.mounted = mounted;
    mounted.instance = new Instance();
    if (rtti.mount)
        rtti.mount(m, owner, sibling);
    else
        mounted.instance.native = (_b = (_a = owner.mounted) === null || _a === void 0 ? void 0 : _a.instance) === null || _b === void 0 ? void 0 : _b.native;
    if (m.args !== exports.RefreshParent)
        reactronic_1.Reactronic.setTraceHint(mounted, reactronic_1.Reactronic.isTraceEnabled ? getManifestTraceHint(m) : m.id);
    if (gTrace && gTraceMask.indexOf('m') >= 0 && new RegExp(gTrace, 'gi').test(getManifestTraceHint(m)))
        console.log(`t${reactronic_1.Transaction.current.id}v${reactronic_1.Transaction.current.timestamp}${'  '.repeat(Math.abs(m.mounted.level))}${getManifestTraceHint(m)}.mounted`);
    return mounted;
}
function callUnmount(m, owner, cause) {
    if (gTrace && gTraceMask.indexOf('u') >= 0 && new RegExp(gTrace, 'gi').test(getManifestTraceHint(m)))
        console.log(`t${reactronic_1.Transaction.current.id}v${reactronic_1.Transaction.current.timestamp}${'  '.repeat(Math.abs(m.mounted.level))}${getManifestTraceHint(m)}.unmounting`);
    if (m.args !== exports.RefreshParent)
        reactronic_1.Reactronic.dispose(m.mounted);
    const rtti = m.rtti;
    if (rtti.unmount)
        rtti.unmount(m, owner, cause);
    else
        unmount(m, owner, cause);
}
function reconcileOrdinaryChildren(owner) {
    var _a, _b;
    const inst = (_a = owner.mounted) === null || _a === void 0 ? void 0 : _a.instance;
    if (inst !== undefined && gPending !== undefined) {
        const buffer = gPending;
        const children = buffer.slice().sort(compareManifests);
        gPending = undefined;
        let sibling = undefined;
        let i = 0, j = 0;
        while (i < inst.children.length) {
            const existing = inst.children[i];
            let e = children[j];
            const diff = e !== undefined ? compareManifests(e, existing) : 1;
            if (diff <= 0) {
                if (sibling !== undefined && e.id === sibling.id)
                    throw new Error(`duplicate id '${sibling.id}' inside '${owner.id}'`);
                if (diff === 0) {
                    e.mounted = existing.mounted;
                    if (e.args !== exports.RefreshParent && argsAreEqual(e.args, existing.args))
                        e = e.annex = children[j] = existing;
                    i++, j++;
                }
                else
                    j++;
                sibling = e;
            }
            else
                callUnmount(existing, owner, existing), i++;
        }
        sibling = undefined;
        for (let e of buffer) {
            const existing = e.annex;
            e = existing !== null && existing !== void 0 ? existing : e;
            const mounted = (_b = e.mounted) !== null && _b !== void 0 ? _b : callMount(e, owner, sibling);
            if (mounted.cycle > 0) {
                if (e.rtti.reorder)
                    e.rtti.reorder(e, owner, sibling);
            }
            e !== existing && callRender(e, owner);
            sibling = e;
        }
        inst.children = children;
    }
}
function reconcileSortedChildren(owner) {
    var _a;
    const inst = (_a = owner.mounted) === null || _a === void 0 ? void 0 : _a.instance;
    if (inst !== undefined && gPending !== undefined) {
        const children = gPending.sort(compareManifests);
        gPending = undefined;
        let sibling = undefined;
        let i = 0, j = 0;
        while (i < inst.children.length || j < children.length) {
            const existing = inst.children[i];
            let e = children[j];
            const diff = compareNullable(e, existing, compareManifests);
            if (diff <= 0) {
                if (sibling !== undefined && e.id === sibling.id)
                    throw new Error(`duplicate id '${sibling.id}' inside '${owner.id}'`);
                if (diff === 0) {
                    e.mounted = existing.mounted;
                    if (e.args !== exports.RefreshParent && argsAreEqual(e.args, existing.args))
                        e = children[j] = existing;
                    i++, j++;
                }
                else
                    callMount(e, owner, sibling), j++;
                e !== existing && callRender(e, owner);
                sibling = e;
            }
            else
                callUnmount(existing, owner, existing), i++;
        }
        inst.children = children;
    }
}
function compareManifests(m1, m2) {
    return m1.id.localeCompare(m2.id);
}
function compareNullable(a, b, comparer) {
    let diff;
    if (b !== undefined)
        diff = a !== undefined ? comparer(a, b) : 1;
    else
        diff = a !== undefined ? -1 : 0;
    return diff;
}
function argsAreEqual(a1, a2) {
    let result = a1 === a2;
    if (!result) {
        if (Array.isArray(a1)) {
            result = Array.isArray(a2) &&
                a1.length === a2.length &&
                a1.every((t, i) => t === a2[i]);
        }
        else if (a1 === Object(a1) && a2 === Object(a2)) {
            for (const p in a1) {
                result = a1[p] === a2[p];
                if (!result)
                    break;
            }
        }
    }
    return result;
}
function getManifestTraceHint(m) {
    return `${m.rtti.name}:${m.id}`;
}
function forEachChildRecursively(m, action) {
    var _a;
    const inst = (_a = m.mounted) === null || _a === void 0 ? void 0 : _a.instance;
    if (inst instanceof Instance) {
        const native = inst.native;
        native && action(native);
        inst.children.forEach(x => forEachChildRecursively(x, action));
    }
}
const RootManifest = new Manifest('root', exports.RefreshParent, () => { }, undefined, { name: 'root', sorting: false }, new Mounted(0, new Instance()));
let gOwner = RootManifest;
let gPending = undefined;
let gTrace = undefined;
let gTraceMask = 'r';
