import { Manifest, Rtti } from '../core/api';
export declare function usingParent<T>(e: HTMLElement, func: (...args: any[]) => T, ...args: any[]): T;
export declare abstract class AbstractHtmlRtti<E extends Element> implements Rtti<E, any> {
    readonly name: string;
    readonly sorting: boolean;
    static isDebugAttributeEnabled: boolean;
    constructor(name: string, sorting?: boolean);
    render(m: Manifest<E, any>): void;
    mount(m: Manifest<E, any>, owner: Manifest, sibling?: Manifest): void;
    protected abstract createElement(m: Manifest<E, any>): E;
    reorder(m: Manifest<E, any>, owner: Manifest, sibling?: Manifest): void;
    unmount(m: Manifest<E, any>, owner: Manifest, cause: Manifest): void;
    static current: Element;
    static unmounting?: Element;
    private static _blinkingEffect;
    static set blinkingEffect(value: string | undefined);
    static get blinkingEffect(): string | undefined;
}
export declare class HtmlRtti<E extends HTMLElement> extends AbstractHtmlRtti<E> {
    protected createElement(m: Manifest<E, any>): E;
}
export declare class SvgRtti<E extends SVGElement> extends AbstractHtmlRtti<E> {
    protected createElement(e: Manifest<E, any>): E;
}
