import { Ref } from 'reactronic';
import { KeyboardModifiers, Sensor } from '../core/api';
export interface ResizedElement {
    readonly borderBoxSize: ReadonlyArray<ResizeObserverSize>;
    readonly contentBoxSize: ReadonlyArray<ResizeObserverSize>;
    readonly contentRect: DOMRectReadOnly;
    readonly resizeData: any;
}
export declare class HtmlResize extends Sensor {
    resizedElements: Array<ResizedElement>;
}
export declare type AllowedDragCursor = 'none' | 'copy' | 'copyLink' | 'copyMove' | 'link' | 'linkMove' | 'move' | 'all' | 'uninitialized';
export declare type DragCursor = 'none' | 'copy' | 'link' | 'move';
export declare enum DragStage {
    Started = 0,
    Dragging = 1,
    Dropped = 2,
    Finished = 3
}
export declare class HtmlDrag extends Sensor {
    private readonly currentEvent;
    stage: DragStage;
    draggingObject: any;
    draggingModifiers: KeyboardModifiers;
    draggingStartAtX: number;
    draggingStartAtY: number;
    droppedAtX: number;
    droppedAtY: number;
    constructor(currentEvent: Ref<Event | undefined>);
    private get event();
    get cursor(): DragCursor;
    set cursor(operation: DragCursor);
    get allowedCursor(): AllowedDragCursor;
    set allowedCursor(operations: AllowedDragCursor);
    allowDropHere(): void;
}
