"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlDrag = exports.DragStage = exports.HtmlResize = void 0;
const reactronic_1 = require("reactronic");
const api_1 = require("../core/api");
class HtmlResize extends api_1.Sensor {
    constructor() {
        super(...arguments);
        this.resizedElements = [];
    }
}
exports.HtmlResize = HtmlResize;
var DragStage;
(function (DragStage) {
    DragStage[DragStage["Started"] = 0] = "Started";
    DragStage[DragStage["Dragging"] = 1] = "Dragging";
    DragStage[DragStage["Dropped"] = 2] = "Dropped";
    DragStage[DragStage["Finished"] = 3] = "Finished";
})(DragStage = exports.DragStage || (exports.DragStage = {}));
class HtmlDrag extends api_1.Sensor {
    constructor(currentEvent) {
        super();
        this.stage = DragStage.Finished;
        this.draggingObject = undefined;
        this.draggingModifiers = api_1.KeyboardModifiers.None;
        this.draggingStartAtX = Infinity;
        this.draggingStartAtY = Infinity;
        this.droppedAtX = Infinity;
        this.droppedAtY = Infinity;
        this.currentEvent = currentEvent;
    }
    get event() {
        const e = this.currentEvent.value;
        if (!(e instanceof DragEvent))
            throw new TypeError('\'currentEvent\' must be of type \'DragEvent\' to perform any drag operations');
        return e;
    }
    get cursor() {
        var _a, _b;
        return (_b = (_a = this.event.dataTransfer) === null || _a === void 0 ? void 0 : _a.dropEffect) !== null && _b !== void 0 ? _b : 'none';
    }
    set cursor(operation) {
        const dataTransfer = this.event.dataTransfer;
        if (dataTransfer)
            dataTransfer.dropEffect = operation;
    }
    get allowedCursor() {
        var _a, _b;
        return (_b = (_a = this.event.dataTransfer) === null || _a === void 0 ? void 0 : _a.effectAllowed) !== null && _b !== void 0 ? _b : 'none';
    }
    set allowedCursor(operations) {
        if (this.stage === DragStage.Started) {
            const dataTransfer = this.event.dataTransfer;
            if (dataTransfer)
                dataTransfer.effectAllowed = operations;
        }
        else {
            throw new Error('\'allowedDragOperations\' must be set during \'Started\' drag stage');
        }
    }
    allowDropHere() {
        this.event.preventDefault();
    }
}
__decorate([
    reactronic_1.unobservable,
    __metadata("design:type", reactronic_1.Ref)
], HtmlDrag.prototype, "currentEvent", void 0);
exports.HtmlDrag = HtmlDrag;
